Attribute VB_Name = "ReadTAG"
Public Type MP3Tag
    hasTag As Boolean
    Songname As String
    Artist As String
    Album As String
    Year As String
    Comment As String
    Track As String
    Genre As Integer
End Type

Public Function ReadTag(FileName As String) As MP3Tag
Dim FF As Byte, N As Long, InBuf As String * 256
FF = FreeFile
'Open File
Open FileName For Binary Access Read As FF
    If LOF(FF) < 256 Then Close FF: Exit Function
    Get #FF, (LOF(FF) - 255), InBuf
Close FF 'ny
Dim p As Long
    p = InStr(1, InBuf, "TAG", vbTextCompare) 'ny
    If p = 0 Then
        With ReadTag
            .hasTag = False
            .Songname = ""
            .Artist = ""
            .Album = ""
            .Year = ""
            .Comment = ""
            .Track = ""
            .Genre = 255
        End With
    Else
        With ReadTag
            .hasTag = True
            .Songname = RTrim(Mid$(InBuf, p + 3, 30))
            .Artist = RTrim(Mid$(InBuf, p + 33, 30))
            .Album = RTrim(Mid$(InBuf, p + 63, 30))
            .Year = RTrim(Mid$(InBuf, p + 93, 4))
            .Comment = RTrim(Mid$(InBuf, p + 97, 29))
            .Track = RTrim(Mid$(InBuf, p + 126, 1))
            .Genre = Asc(RTrim(Mid$(InBuf, p + 127, 1)))
    End With
End If
End Function


Public Function StartTagging(List As ListBox) As Long

If List.ListCount = 0 Then StartTagging = 0: Exit Function

Dim i As Long, sn As String

Mp3TagSet.TagBar.Max = List.ListCount - 0.9
Mp3TagSet.TagBar.Min = 0.1

If Mp3TagSet.hasTag.Value = vbChecked Then 'Clear Tags

    For i = 0 To List.ListCount - 1
        Call ClearTAG(List.List(i))
        Mp3TagSet.TagBar.Value = i + 0.1
        Mp3TagSet.TagBar.Text = i & " of " & List.ListCount
        Mp3TagSet.lMp3Now.Text = "Clearing TAG To File: " & List.List(i)
        DoEvents
    Next i
    StartTagging = i

Else 'Set TAG by Expression
    
    For i = 0 To List.ListCount - 1
        sn = Replace(List.List(i), List.Tag, "")
        Call WriteTAG.WriteTAG(List.List(i), GetExpression(sn, 0), GetExpression(sn, 1), GetExpression(sn, 2), GetExpression(sn, 3), GetExpression(sn, 4), Mp3TagSet.tGenre.ItemData(Mp3TagSet.tGenre.ListIndex))
        Mp3TagSet.TagBar.Value = i + 1.1
        Mp3TagSet.TagBar.Text = i + 1 & " of " & List.ListCount
        Mp3TagSet.lMp3Now.Text = "Setting TAG To File: " & sn
        DoEvents
    Next i
    StartTagging = i

End If
Mp3TagSet.lMp3Now.Text = "Press 'Start' to set TAG to mp3 files"
End Function

Public Function GetExpression(FileName As String, Id As Integer) As String
Dim s As Long, e As Long, se As String
Dim cs As String * 1, ce As String * 1
Dim ads As String, ade As String
Dim exp As String

With Mp3TagSet

exp = .tExpression.Text
    
    Select Case Id
    Case 0 'SongName (%N)
        s = InStr(1, exp, "%N", vbTextCompare)
        ads = Mid(.tName.Text, 1, InStr(1, .tName.Text, "%N", vbTextCompare))
        ade = Mid(.tName, InStr(1, .tName.Text, "%N", vbTextCompare) + 1)
    Case 1 'Artist (%A)
        s = InStr(1, exp, "%A", vbTextCompare)
        ads = Mid(.tArtist.Text, 1, InStr(1, .tArtist.Text, "%A", vbTextCompare))
        ade = Mid(.tArtist, InStr(1, .tArtist.Text, "%A", vbTextCompare) + 1)
    Case 2 'Album (%L)
        s = InStr(1, exp, "%L", vbTextCompare)
        ads = Mid(.tAlbum.Text, 1, InStr(1, .tAlbum.Text, "%L", vbTextCompare))
        ade = Mid(.tAlbum, InStr(1, .tAlbum.Text, "%L", vbTextCompare) + 1)
    Case 3 'Year (%Y)
        s = InStr(1, exp, "%Y", vbTextCompare)
        ads = Mid(.tYear.Text, 1, InStr(1, .tYear.Text, "%Y", vbTextCompare))
        ade = Mid(.tYear, InStr(1, .tYear.Text, "%Y", vbTextCompare) + 1)
    Case 4 'Comment (%C)
        s = InStr(1, exp, "%C", vbTextCompare)
        ads = Mid(.tComment.Text, 1, InStr(1, .tComment.Text, "%C", vbTextCompare) - 1)
        ade = Mid(.tComment, InStr(1, .tComment.Text, "%C", vbTextCompare) + 2)
    End Select
End With
        If s <> 0 Then
        e = s + 2
        If s <> 1 Then
        cs = Mid(exp, s - 1, 1)
        Else: cs = Chr(0)
        End If
        ce = Mid(exp, e, 1)
        
        If cs <> Chr(0) Then
        s = InStr(1, FileName, cs, vbBinaryCompare) + 1
        Else: s = 1
        End If
        e = InStr(s + 1, FileName, ce, vbBinaryCompare)
        
        se = Trim(Mid(FileName, s, e - s))
        End If
        
        GetExpression = Trim(ads & se & ade)
End Function


